Index: /code/trunk/src/libraries/util/OgreForwardRefs.h
===================================================================
--- /code/trunk/src/libraries/util/OgreForwardRefs.h	(revision 7167)
+++ /code/trunk/src/libraries/util/OgreForwardRefs.h	(revision 7168)
@@ -75,14 +75,14 @@
     class GpuProgramPtr;
     class GpuProgramManager;
-	class GpuProgramUsage;
+    class GpuProgramUsage;
     class HardwareIndexBuffer;
     class HardwareOcclusionQuery;
     class HardwareVertexBuffer;
-	class HardwarePixelBuffer;
+    class HardwarePixelBuffer;
     class HardwarePixelBufferSharedPtr;
-	class HighLevelGpuProgram;
+    class HighLevelGpuProgram;
     class HighLevelGpuProgramPtr;
-	class HighLevelGpuProgramManager;
-	class HighLevelGpuProgramFactory;
+    class HighLevelGpuProgramManager;
+    class HighLevelGpuProgramFactory;
     class IndexData;
     class IntersectionSceneQuery;
@@ -93,6 +93,6 @@
     class Log;
     class LogManager;
-	class ManualResourceLoader;
-	class ManualObject;
+    class ManualResourceLoader;
+    class ManualObject;
     class Material;
     class MaterialPtr;
@@ -111,8 +111,8 @@
     class MovablePlane;
     class Node;
-	class NodeAnimationTrack;
-	class NodeKeyFrame;
-	class NumericAnimationTrack;
-	class NumericKeyFrame;
+    class NodeAnimationTrack;
+    class NodeKeyFrame;
+    class NumericAnimationTrack;
+    class NumericKeyFrame;
     class Overlay;
     class OverlayContainer;
@@ -135,11 +135,11 @@
     class Plane;
     class PlaneBoundedVolume;
-	class Plugin;
+    class Plugin;
     class Pose;
     class ProgressiveMesh;
     class Profile;
-	class Profiler;
+    class Profiler;
     class Quaternion;
-	class Radian;
+    class Radian;
     class Ray;
     class RaySceneQuery;
@@ -149,6 +149,6 @@
     class RenderQueue;
     class RenderQueueGroup;
-	class RenderQueueInvocation;
-	class RenderQueueInvocationSequence;
+    class RenderQueueInvocation;
+    class RenderQueueInvocationSequence;
     class RenderQueueListener;
     class RenderSystem;
@@ -157,13 +157,13 @@
     class RenderTargetListener;
     class RenderTexture;
-	class MultiRenderTarget;
+    class MultiRenderTarget;
     class RenderWindow;
     class RenderOperation;
     class Resource;
-	class ResourceBackgroundQueue;
-	class ResourceGroupManager;
+    class ResourceBackgroundQueue;
+    class ResourceGroupManager;
     class ResourceManager;
     class RibbonTrail;
-	class Root;
+    class Root;
     class SceneManager;
     class SceneManagerEnumerator;
@@ -171,9 +171,9 @@
     class SceneQuery;
     class SceneQueryListener;
-	class ScriptLoader;
+    class ScriptLoader;
     class Serializer;
     class ShadowCaster;
     class ShadowRenderable;
-	class ShadowTextureManager;
+    class ShadowTextureManager;
     class SimpleRenderable;
     class SimpleSpline;
@@ -184,20 +184,20 @@
     class Sphere;
     class SphereSceneQuery;
-	class StaticGeometry;
+    class StaticGeometry;
     class StringConverter;
     class StringInterface;
     class SubEntity;
     class SubMesh;
-	class TagPoint;
+    class TagPoint;
     class Technique;
-	class TempBlendedBufferInfo;
-	class ExternalTextureSource;
+    class TempBlendedBufferInfo;
+    class ExternalTextureSource;
     class TextureUnitState;
     class Texture;
     class TexturePtr;
-	class TextureFont;
+    class TextureFont;
     class TextureManager;
     class TransformKeyFrame;
-	class Timer;
+    class Timer;
     class UserDefinedObject;
     class Vector2;
@@ -205,9 +205,9 @@
     class Vector4;
     class Viewport;
-	class VertexAnimationTrack;
+    class VertexAnimationTrack;
     class VertexBufferBinding;
     class VertexData;
     class VertexDeclaration;
-	class VertexMorphKeyFrame;
+    class VertexMorphKeyFrame;
     class WireBoundingBox;
     class Compositor;
Index: /code/trunk/src/orxonox/controllers/AIController.cc
===================================================================
--- /code/trunk/src/orxonox/controllers/AIController.cc	(revision 7167)
+++ /code/trunk/src/orxonox/controllers/AIController.cc	(revision 7168)
@@ -212,8 +212,8 @@
                 if (this->target_)
                 {
-				if (!this->target_->getRadarVisibility()) /* So AI won't shoot invisible Spaceships */
-                	this->forgetTarget();
-                else this->aimAtTarget();
-            }
+                    if (!this->target_->getRadarVisibility()) /* So AI won't shoot invisible Spaceships */
+                        this->forgetTarget();
+                    else this->aimAtTarget();
+                }
 
                 if (this->bHasTargetPosition_)
@@ -245,6 +245,6 @@
             if (this->target_)
             {
-				if (!this->target_->getRadarVisibility()) /* So AI won't shoot invisible Spaceships */
-                	this->forgetTarget();
+                if (!this->target_->getRadarVisibility()) /* So AI won't shoot invisible Spaceships */
+                    this->forgetTarget();
                 else this->aimAtTarget();
             }