Index: /branches/shared_lib/configure.ac
===================================================================
--- /branches/shared_lib/configure.ac	(revision 7169)
+++ /branches/shared_lib/configure.ac	(revision 7170)
@@ -42,4 +42,5 @@
 #########################
 AC_PROG_CXX
+AC_LIBTOOL_DLOPEN
 AC_PROG_LIBTOOL
 AC_HEADER_STDC
Index: /branches/shared_lib/src/Makefile.am
===================================================================
--- /branches/shared_lib/src/Makefile.am	(revision 7169)
+++ /branches/shared_lib/src/Makefile.am	(revision 7170)
@@ -13,5 +13,5 @@
 
 orxonox_CPPFLAGS = -DIS_ORXONOX
-orxonox_LDFLAGS =  -rdynamic -ldl
+orxonox_LDFLAGS =
 
 orxonox_DEPENDENCIES = \
Index: /branches/shared_lib/src/defs/include_paths.am
===================================================================
--- /branches/shared_lib/src/defs/include_paths.am	(revision 7169)
+++ /branches/shared_lib/src/defs/include_paths.am	(revision 7170)
@@ -1,37 +1,37 @@
-AM_CXXFLAGS=-I$(MAINSRCDIR)
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/world_entities
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/story_entities
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/coord
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/event
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/text_engine
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/spatial_separation
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/render2D
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/particles
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui/gtk_gui
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui/gl_gui
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gui/gl_gui/glmenu
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/shell
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/util
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/math
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/network
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/tinyxml
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/physics/fields
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/collision_detection
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/newmat
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/sound
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/defs
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/font
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/network
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/util
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/animation
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/common
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/loading
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/util/track
-AM_CXXFLAGS+=-I$(MAINSRCDIR)/subprojects
+INCLUDES =  -I$(MAINSRCDIR) \
+            -I$(MAINSRCDIR)/world_entities \
+            -I$(MAINSRCDIR)/story_entities \
+            -I$(MAINSRCDIR)/lib \
+            -I$(MAINSRCDIR)/lib/coord \
+            -I$(MAINSRCDIR)/lib/data \
+            -I$(MAINSRCDIR)/lib/event \
+            -I$(MAINSRCDIR)/lib/graphics \
+            -I$(MAINSRCDIR)/lib/graphics/text_engine \
+            -I$(MAINSRCDIR)/lib/graphics/importer \
+            -I$(MAINSRCDIR)/lib/graphics/spatial_separation \
+            -I$(MAINSRCDIR)/lib/graphics/render2D \
+            -I$(MAINSRCDIR)/lib/particles \
+            -I$(MAINSRCDIR)/lib/gui/gtk_gui \
+            -I$(MAINSRCDIR)/lib/gui/gl_gui \
+            -I$(MAINSRCDIR)/lib/gui/gl_gui/glmenu \
+            -I$(MAINSRCDIR)/lib/lang \
+            -I$(MAINSRCDIR)/lib/shell \
+            -I$(MAINSRCDIR)/lib/util \
+            -I$(MAINSRCDIR)/lib/math \
+            -I$(MAINSRCDIR)/lib/network \
+            -I$(MAINSRCDIR)/lib/tinyxml \
+            -I$(MAINSRCDIR)/lib/physics \
+            -I$(MAINSRCDIR)/lib/physics/fields \
+            -I$(MAINSRCDIR)/lib/collision_detection \
+            -I$(MAINSRCDIR)/lib/newmat \
+            -I$(MAINSRCDIR)/lib/sound \
+            -I$(MAINSRCDIR)/defs \
+            -I$(MAINSRCDIR)/font \
+            -I$(MAINSRCDIR)/network \
+            -I$(MAINSRCDIR)/ai \
+            -I$(MAINSRCDIR)/util \
+            -I$(MAINSRCDIR)/util/animation \
+            -I$(MAINSRCDIR)/util/common \
+            -I$(MAINSRCDIR)/util/loading \
+            -I$(MAINSRCDIR)/util/track \
+            -I$(MAINSRCDIR)/subprojects
Index: /branches/shared_lib/src/orxonox.cc
===================================================================
--- /branches/shared_lib/src/orxonox.cc	(revision 7169)
+++ /branches/shared_lib/src/orxonox.cc	(revision 7170)
@@ -341,5 +341,5 @@
 //     return false;
 //   }
-  DynamicLoader::loadDyLib("./src/world_entities/.libs/libORXground_turret.so");
+  DynamicLoader::loadDyLib("libORXground_turret.so");
 
   // start the collision detection engine
Index: /branches/shared_lib/src/world_entities/Makefile.am
===================================================================
--- /branches/shared_lib/src/world_entities/Makefile.am	(revision 7169)
+++ /branches/shared_lib/src/world_entities/Makefile.am	(revision 7170)
@@ -4,6 +4,6 @@
 
 noinst_LIBRARIES = libORXwe.a
-#lib_LTLIBRARIES = libORXground_turret.la
-#libORXground_turret_la_SOURCES = npcs/ground_turret.cc
+pkglib_LTLIBRARIES = libORXground_turret.la
+libORXground_turret_la_SOURCES = npcs/ground_turret.cc
 
 ## THESE ARE THE BASE CLASSES OF ALL WORLD_ENTITIES