Index: code/trunk/src/orxonox/worldentities/BigExplosion.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/BigExplosion.cc	(revision 7174)
+++ code/trunk/src/orxonox/worldentities/BigExplosion.cc	(revision 7176)
@@ -29,9 +29,6 @@
 #include "BigExplosion.h"
 
-//#include <sstream>
-
 #include "util/Exception.h"
 #include "core/CoreIncludes.h"
-#include "core/CommandExecutor.h"
 #include "core/Executor.h"
 #include "core/GameMode.h"
@@ -40,4 +37,5 @@
 #include "graphics/ParticleSpawner.h"
 #include "graphics/Model.h"
+#include "MovableEntity.h"
 
 namespace orxonox
@@ -45,5 +43,5 @@
     CreateFactory(BigExplosion);
 
-    BigExplosion::BigExplosion(BaseObject* creator) : MovableEntity(creator)
+    BigExplosion::BigExplosion(BaseObject* creator) : StaticEntity(creator)
     {
         RegisterObject(BigExplosion);
@@ -51,19 +49,8 @@
         if ( GameMode::showsGraphics() && ( !this->getScene() || !this->getScene()->getSceneManager() ) )
             ThrowException(AbortLoading, "Can't create BigExplosion, no scene or no scene manager given.");
-/*
-        this->cps_ = 1;
-        this->firstTick_ = true;
-*/
+
         this->bStop_ = false;
         this->LOD_ = LODParticle::Normal;
 
-/*      this->stf_ = "setTimeFactor ";
-        this->timeFactor_ =  1;
-        std::ostringstream o;
-        o << stf_ << this->timeFactor_;
-        CommandExecutor::execute(o.str() ,false);
-        this->timeFactor_ = 0.1;
-*/
-
         if ( GameMode::showsGraphics() )
         {
@@ -85,11 +72,7 @@
         if (GameMode::isMaster())
         {
-            Vector3 velocity(rnd(-1, 1), rnd(-1, 1), rnd(-1, 1));
-            velocity.normalise();
-            velocity *= rnd(20, 30);
-            this->setVelocity(velocity);
-
             this->destroyTimer_.setTimer(rnd(2, 4), false, createExecutor(createFunctor(&BigExplosion::stop, this)));
         }
+
         this->registerVariables();
     }
@@ -101,5 +84,5 @@
         this->debrisEntity3_ = new MovableEntity(this);
         this->debrisEntity4_ = new MovableEntity(this);
-        
+
         this->debrisEntity1_->setSyncMode(0);
         this->debrisEntity2_->setSyncMode(0);
@@ -111,5 +94,5 @@
         this->debris3_ = new Model(this);
         this->debris4_ = new Model(this);
-        
+
         this->debris1_->setSyncMode(0);
         this->debris2_->setSyncMode(0);
@@ -194,5 +177,5 @@
             MovableEntity* partEntity1 = new MovableEntity(this);
             MovableEntity* partEntity2 = new MovableEntity(this);
-            
+
             part1->setSyncMode(0);
             part2->setSyncMode(0);
@@ -360,30 +343,3 @@
     }
 */
-
-     void BigExplosion::tick(float dt)
-    {
-//        static const unsigned int CHANGES_PER_SECOND = 10;
-
-
-/*        if (GameMode::isMaster() && rnd() < dt*(this->cps_))
-        {
-
-            if(this->timeFactor_ < 1 )
-                this->timeFactor_ += 0.05;
-
-            if(this->firstTick_)
-                this->cps_ = 256;
-
-            std::ostringstream o;
-            o << this->stf_ << this->timeFactor_;
-            CommandExecutor::execute(o.str() ,false);
-            if(this->cps_>50)
-                this->cps_/=2;
-            this->firstTick_ = false;
-            COUT(0) << timeFactor_ << std::endl;
-        }
-*/
-
-        SUPER(BigExplosion, tick, dt);
-    }
 }
Index: code/trunk/src/orxonox/worldentities/BigExplosion.h
===================================================================
--- code/trunk/src/orxonox/worldentities/BigExplosion.h	(revision 7174)
+++ code/trunk/src/orxonox/worldentities/BigExplosion.h	(revision 7176)
@@ -32,17 +32,14 @@
 #include "OrxonoxPrereqs.h"
 
-#include <string>
 #include "tools/Timer.h"
-#include "MovableEntity.h"
+#include "StaticEntity.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport BigExplosion : public MovableEntity
+    class _OrxonoxExport BigExplosion : public StaticEntity
     {
         public:
             BigExplosion(BaseObject* creator);
             virtual ~BigExplosion();
-
-            virtual void tick(float dt);
 
             inline void setLOD(LODParticle::Value level)
@@ -62,11 +59,4 @@
 
             bool                  bStop_;
-            bool                  firstTick_;
-
-            std::string           stf_;
-
-            unsigned int          cps_;
-
-            double                timeFactor_;
 
             StaticEntity*         explosion_;