Index: branches/shared_lib/src/Makefile.am
===================================================================
--- branches/shared_lib/src/Makefile.am	(revision 7176)
+++ branches/shared_lib/src/Makefile.am	(revision 7177)
@@ -2,5 +2,4 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-include world_entities/WorldEntities.am
 include story_entities/Makefile.am
 
@@ -27,5 +26,4 @@
 
 orxonox_SOURCES = \
-		$(WorldEntities_SOURCES_) \
 		$(StoryEntities_SOURCES_) \
 		orxonox.cc \
Index: branches/shared_lib/src/orxonox.cc
===================================================================
--- branches/shared_lib/src/orxonox.cc	(revision 7176)
+++ branches/shared_lib/src/orxonox.cc	(revision 7177)
@@ -282,5 +282,6 @@
     NetworkManager::getInstance()->establishConnection(this->serverName, port);
   }
-  else if( this->port > 0) {    // we are a server
+  else if( this->port > 0)
+  {    // we are a server
     State::setOnline(true);
     NetworkManager::getInstance()->createServer(port);
@@ -337,6 +338,16 @@
       DynamicLoader::addSearchDir(PKG_LIBDIR);
 
-  DynamicLoader::loadDyLib("libORXground_turret");
+  /// FIXME make this more modular (search for himself for all the libraries
   printf("%s\n", DynamicLoader::getSearchDir());
+  DynamicLoader::loadDyLib("libORXenvironmentals");
+  DynamicLoader::loadDyLib("libORXplayables");
+  DynamicLoader::loadDyLib("libORXweapons");
+  DynamicLoader::loadDyLib("libORXprojectiles");
+  DynamicLoader::loadDyLib("libORXpower_ups");
+  DynamicLoader::loadDyLib("libORXmisc_entities");
+  DynamicLoader::loadDyLib("libORXnpcs_ground.la");
+  DynamicLoader::loadDyLib("libORXnpcs_air");
+  printf("%s\n", DynamicLoader::getSearchDir());
+
   // start the collision detection engine
   CDEngine::getInstance();
Index: branches/shared_lib/src/util/loading/dynamic_loader.cc
===================================================================
--- branches/shared_lib/src/util/loading/dynamic_loader.cc	(revision 7176)
+++ branches/shared_lib/src/util/loading/dynamic_loader.cc	(revision 7177)
@@ -75,4 +75,5 @@
 {
   DynamicLoader::initialize();
+
   void* handle;
   handle = lt_dlopenext(libName);
Index: branches/shared_lib/src/world_entities/Makefile.am
===================================================================
--- branches/shared_lib/src/world_entities/Makefile.am	(revision 7176)
+++ branches/shared_lib/src/world_entities/Makefile.am	(revision 7177)
@@ -1,11 +1,9 @@
 MAINSRCDIR=..
 include $(MAINSRCDIR)/defs/include_paths.am
-include WorldEntities.am
 
 noinst_LIBRARIES = libORXwe.a
 
-pkglib_LTLIBRARIES = libORXground_turret.la
-libORXground_turret_la_SOURCES = npcs/ground_turret.cc
-
+## TODO ::
+WRONG_SORTED_SOURCES_ = space_ships/space_ship.cc
 
 
@@ -32,7 +30,78 @@
 		spawning_point.cc \
 		\
+		skybox.cc \
+		terrain.cc \
 		\
-		effects/explosion.cc
+		elements/image_entity.cc \
+		elements/text_element.cc \
+		\
+		effects/explosion.cc \
+		\
+		$(WRONG_SORTED_SOURCES_)
 
+LD_FLAGS = --export-dynamic
+
+pkglib_LTLIBRARIES = \
+		libORXnpcs_ground.la \
+		libORXnpcs_air.la \
+		libORXenvironmentals.la \
+		libORXweapons.la \
+		libORXprojectiles.la \
+		libORXpower_ups.la \
+		libORXplayables.la \
+		libORXmisc_entities.la
+
+libORXnpcs_ground_la_SOURCES = \
+		npcs/ground_turret.cc
+
+libORXnpcs_air_la_SOURCES = \
+		npcs/npc_test1.cc \
+		npcs/npc_test.cc
+
+libORXenvironmentals_la_SOURCES = \
+		environment.cc \
+		skysphere.cc \
+		satellite.cc \
+		character_attributes.cc \
+		test_entity.cc \
+		planet.cc \
+		environments/water.cc \
+		environments/model_entity.cc \
+		environments/building.cc \
+		\
+		movie_entity.cc \
+		recorder.cc
+
+libORXweapons_la_SOURCES = \
+		weapons/turret.cc \
+		weapons/aiming_turret.cc \
+		weapons/targeting_turret.cc \
+		weapons/cannon.cc \
+		weapons/hyperblaster.cc \
+		weapons/aim.cc
+
+#		weapons/test_gun.cc
+
+libORXprojectiles_la_SOURCES = \
+		projectiles/bomb.cc \
+		projectiles/laser.cc \
+		projectiles/test_bullet.cc \
+		projectiles/rocket.cc \
+		projectiles/guided_missile.cc \
+		projectiles/hyperblast.cc
+
+libORXpower_ups_la_SOURCES = \
+		power_ups/turret_power_up.cc \
+		power_ups/laser_power_up.cc
+
+libORXplayables_la_SOURCES = \
+		space_ships/helicopter.cc \
+		space_ships/hover.cc \
+		space_ships/turbine_hover.cc \
+		creatures/md2_creature.cc
+
+libORXmisc_entities_la_SOURCES = \
+		\
+		effects/lightning_bolt.cc
 
 
@@ -62,6 +131,50 @@
 		effects/explosion.h \
 		\
-		$(WorldEntities_HEADERS_)
+		\
+		\
+		npcs/npc_test.h \
+		npcs/npc_test1.h \
+		npcs/ground_turret.h \
+		environment.h \
+		skysphere.h \
+		skybox.h \
+		terrain.h \
+		satellite.h \
+		movie_entity.h \
+		recorder.h \
+		character_attributes.h \
+		test_entity.h \
+		planet.h \
+		\
+		weapons/test_gun.h \
+		weapons/cannon.h \
+		weapons/hyperblaster.h \
+		weapons/turret.h \
+		weapons/aiming_turret.h \
+		weapons/targeting_turret.h \
+		weapons/aim.h \
+		\
+		projectiles/bomb.h \
+		projectiles/laser.h \
+		projectiles/test_bullet.h \
+		projectiles/rocket.h \
+		projectiles/guided_missile.h \
+		projectiles/hyperblast.h \
+		\
+		power_ups/turret_power_up.h \
+		power_ups/laser_power_up.h \
+		\
+		space_ships/space_ship.h \
+		space_ships/helicopter.h \
+		space_ships/hover.h \
+		space_ships/turbine_hover.h \
+		creatures/md2_creature.h \
+		\
+		environments/water.h \
+		environments/model_entity.h \
+		environments/building.h \
+		elements/image_entity.h \
+		elements/text_element.h \
+		\
+		effects/lightning_bolt.h
 
-
-EXTRA_DIST = WorldEntities.am
Index: branches/shared_lib/src/world_entities/WorldEntities.am
===================================================================
--- branches/shared_lib/src/world_entities/WorldEntities.am	(revision 7176)
+++ branches/shared_lib/src/world_entities/WorldEntities.am	(revision 7177)
@@ -50,49 +50,2 @@
 
 
-WorldEntities_HEADERS_ = \
-		npcs/npc_test.h \
-		npcs/npc_test1.h \
-		npcs/ground_turret.h \
-		environment.h \
-		skysphere.h \
-		skybox.h \
-		terrain.h \
-		satellite.h \
-		movie_entity.h \
-		recorder.h \
-		character_attributes.h \
-		test_entity.h \
-		planet.h \
-		\
-		weapons/test_gun.h \
-		weapons/cannon.h \
-		weapons/hyperblaster.h \
-		weapons/turret.h \
-		weapons/aiming_turret.h \
-		weapons/targeting_turret.h \
-		weapons/aim.h \
-		\
-		projectiles/bomb.h \
-		projectiles/laser.h \
-		projectiles/test_bullet.h \
-		projectiles/rocket.h \
-		projectiles/guided_missile.h \
-		projectiles/hyperblast.h \
-		\
-		power_ups/turret_power_up.h \
-		power_ups/laser_power_up.h \
-		\
-		space_ships/space_ship.h \
-		space_ships/helicopter.h \
-		space_ships/hover.h \
-		space_ships/turbine_hover.h \
-		creatures/md2_creature.h \
-		\
-		environments/water.h \
-		environments/model_entity.h \
-		environments/building.h \
-		\
-		elements/image_entity.h \
-		elements/text_element.h \
-		\
-		effects/lightning_bolt.h
Index: branches/shared_lib/src/world_entities/creatures/md2_creature.cc
===================================================================
--- branches/shared_lib/src/world_entities/creatures/md2_creature.cc	(revision 7176)
+++ branches/shared_lib/src/world_entities/creatures/md2_creature.cc	(revision 7177)
@@ -26,7 +26,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "factory.h"
@@ -80,14 +77,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
-
-  cannon->setName("BFG");
-
-   this->getWeaponManager()->addWeapon(wpLeft, 1, 0);
-   this->getWeaponManager()->addWeapon(wpRight,1 ,1);
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
+//  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+
+//  cannon->setName("BFG");
+
+   //this->getWeaponManager()->addWeapon(wpLeft, 1, 0);
+   //this->getWeaponManager()->addWeapon(wpRight,1 ,1);
 //   this->getWeaponManager()->addWeapon(cannon, 0, 6);
 
Index: branches/shared_lib/src/world_entities/space_ships/helicopter.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/helicopter.cc	(revision 7176)
+++ branches/shared_lib/src/world_entities/space_ships/helicopter.cc	(revision 7177)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "factory.h"
@@ -82,14 +79,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
   Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
 
   cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
   this->addWeapon(cannon, 0, 6);
 
Index: branches/shared_lib/src/world_entities/space_ships/hover.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/hover.cc	(revision 7176)
+++ branches/shared_lib/src/world_entities/space_ships/hover.cc	(revision 7177)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "factory.h"
@@ -74,15 +71,15 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
-
-  cannon->setName("BFG");
-
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
-  this->addWeapon(cannon, 0, 2);
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
+//  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
+
+//  cannon->setName("BFG");
+
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(cannon, 0, 2);
 
   this->getWeaponManager()->changeWeaponConfig(1);
Index: branches/shared_lib/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/space_ship.cc	(revision 7176)
+++ branches/shared_lib/src/world_entities/space_ships/space_ship.cc	(revision 7177)
@@ -23,6 +23,4 @@
 #include "resource_manager.h"
 
-#include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
 #include "weapons/turret.h"
 #include "weapons/cannon.h"
@@ -126,14 +124,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+  //Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate("TestGun"));
+  //wpRight->setName("testGun Right");
+  //Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate("TestGun"));
+  //wpLeft->setName("testGun Left");
   //Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
 
   //cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+  //this->addWeapon(wpLeft, 1, 0);
+  //this->addWeapon(wpRight,1 ,1);
   //this->addWeapon(cannon, 0, 6);
 
Index: branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc	(revision 7176)
+++ branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc	(revision 7177)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "factory.h"
@@ -76,14 +73,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
   //Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
 
   //  cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
   //this->addWeapon(cannon, 0, 2);
 