Index: branches/shared_lib/src/lib/graphics/Makefile.am
===================================================================
--- branches/shared_lib/src/lib/graphics/Makefile.am	(revision 7168)
+++ branches/shared_lib/src/lib/graphics/Makefile.am	(revision 7178)
@@ -4,37 +4,39 @@
 noinst_LIBRARIES = libORXgraphics.a
 
-libORXgraphics_a_SOURCES = graphics_engine.cc \
-			   light.cc \
-			   shader.cc \
-			   \
-			   render2D/render_2d.cc \
-			   render2D/element_2d.cc \
-			   render2D/billboard.cc \
-			   \
-			   text_engine/text_engine.cc \
-			   text_engine/text.cc \
-			   text_engine/font.cc \
-			   \
-			   effects/graphics_effect.cc \
-			   effects/fog_effect.cc \
-			   effects/lense_flare.cc
+libORXgraphics_a_SOURCES = \
+		graphics_engine.cc \
+		light.cc \
+		shader.cc \
+		\
+		render2D/render_2d.cc \
+		render2D/element_2d.cc \
+		render2D/billboard.cc \
+		\
+		text_engine/text_engine.cc \
+		text_engine/text.cc \
+		text_engine/font.cc \
+		\
+		effects/graphics_effect.cc \
+		effects/fog_effect.cc \
+		effects/lense_flare.cc
 
 
-noinst_HEADERS = graphics_engine.h \
-		 light.h \
-		 shader.h \
-		 \
-		 render2D/render_2d.h \
-		 render2D/element_2d.h \
-		 render2D/billboard.h \
-		 \
-		 text_engine/text_engine.h \
-		 text_engine/text.h \
-		 text_engine/font.h \
-		 text_engine/default_font.xpm \
-		 \
-		 effects/graphics_effect.h \
-		 effects/fog_effect.h \
-		 effects/lense_flare.h
+noinst_HEADERS = \
+		graphics_engine.h \
+		light.h \
+		shader.h \
+		\
+		render2D/render_2d.h \
+		render2D/element_2d.h \
+		render2D/billboard.h \
+		\
+		text_engine/text_engine.h \
+		text_engine/text.h \
+		text_engine/font.h \
+		text_engine/default_font.xpm \
+		\
+		effects/graphics_effect.h \
+		effects/fog_effect.h \
+		effects/lense_flare.h
 
 
Index: branches/shared_lib/src/lib/graphics/importer/Makefile.am
===================================================================
--- branches/shared_lib/src/lib/graphics/importer/Makefile.am	(revision 7168)
+++ branches/shared_lib/src/lib/graphics/importer/Makefile.am	(revision 7178)
@@ -2,37 +2,37 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-noinst_LIBRARIES = libORXimporter.a libtc.a
+pkglib_LTLIBRARIES = libORXimporter.la
 
-libORXimporter_a_SOURCES = model.cc \
-                           vertex_array_model.cc \
-                           grid.cc \
-                           static_model.cc \
-                           objModel.cc \
-                           primitive_model.cc \
-                           md2Model.cc \
-                           material.cc \
-                           texture.cc \
-                           texture_sequence.cc \
-                           height_map.cc \
-                           media_container.cc \
-                           movie_player.cc
+libORXimporter_la_SOURCES = \
+		model.cc \
+		tc.cc \
+		vertex_array_model.cc \
+		grid.cc \
+		static_model.cc \
+		objModel.cc \
+		primitive_model.cc \
+		md2Model.cc \
+		material.cc \
+		texture.cc \
+		texture_sequence.cc \
+		height_map.cc \
+		media_container.cc \
+		movie_player.cc
 
-libtc_a_SOURCES  = tc.cc
-
-
-noinst_HEADERS = model.h \
-		 tc.h \
-                 vertex_array_model.h \
-                 grid.h \
-                 static_model.h \
-                 objModel.h \
-                 primitive_model.h \
-                 md2Model.h \
-                 material.h \
-                 texture.h \
-                 texture_sequence.h \
-                 height_map.h \
-                 anorms.h \
-                 anormtab.h \
-                 media_container.h \
-                 movie_player.h
+noinst_HEADERS = \
+		model.h \
+		tc.h \
+		vertex_array_model.h \
+		grid.h \
+		static_model.h \
+		objModel.h \
+		primitive_model.h \
+		md2Model.h \
+		material.h \
+		texture.h \
+		texture_sequence.h \
+		height_map.h \
+		anorms.h \
+		anormtab.h \
+		media_container.h \
+		movie_player.h