Index: code/trunk/src/orxonox/ChatInputHandler.cc
===================================================================
--- code/trunk/src/orxonox/ChatInputHandler.cc	(revision 7182)
+++ code/trunk/src/orxonox/ChatInputHandler.cc	(revision 7183)
@@ -129,5 +129,5 @@
     { this->text_colors[ i ] = new CEGUI::colour( red, green, blue );
       assert( this->text_colors[ i ] );
-      green += 0.2, blue += 0.2;
+      green += 0.2f, blue += 0.2f;
     }
 
@@ -137,5 +137,5 @@
     { this->text_colors[ i ] = new CEGUI::colour( red, green, blue );
       assert( this->text_colors[ i ] );
-      red += 0.2, blue += 0.2;
+      red += 0.2f, blue += 0.2f;
     }
 
@@ -145,5 +145,5 @@
     { this->text_colors[ i ] = new CEGUI::colour( red, green, blue );
       assert( this->text_colors[ i ] );
-      red += 0.2, green += 0.2;
+      red += 0.2f, green += 0.2f;
     }
   }
@@ -275,5 +275,5 @@
     {
       /* adjust curser position - magic number 5 for font width */
-      sub_adjust_dispoffset( (this->input->getUnclippedInnerRect().getWidth()/6),
+      sub_adjust_dispoffset( (int)(this->input->getUnclippedInnerRect().getWidth()/6),
         cursorpos, assembled.length() );
       this->input->setProperty( "Text", assembled.substr( disp_offset ) );
@@ -282,5 +282,5 @@
     {
       /* adjust curser position - magic number 5 for font width */
-      sub_adjust_dispoffset( (this->inputonly->getUnclippedInnerRect().getWidth()/6),
+      sub_adjust_dispoffset( (int)(this->inputonly->getUnclippedInnerRect().getWidth()/6),
         cursorpos, assembled.length() );
       this->inputonly->setProperty( "Text", assembled.substr( disp_offset) );
Index: code/trunk/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 7182)
+++ code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 7183)
@@ -498,12 +498,12 @@
             {
                 pos = Vector3::ZERO;
-                if (i <= 1) pos += dest  + FORMATION_WIDTH*(orient*WorldEntity::LEFT);
-                if (i == 2) pos += dest  + FORMATION_WIDTH*(orient*WorldEntity::RIGHT);
-                if (i == 3) pos += dest  + FORMATION_WIDTH*(orient*WorldEntity::UP);
+                if (i <= 1) pos += dest  + (float)FORMATION_WIDTH*(orient*WorldEntity::LEFT);
+                if (i == 2) pos += dest  + (float)FORMATION_WIDTH*(orient*WorldEntity::RIGHT);
+                if (i == 3) pos += dest  + (float)FORMATION_WIDTH*(orient*WorldEntity::UP);
                 if (i >= 4)
                 {
-                    pos += dest  + FORMATION_WIDTH*(orient*WorldEntity::DOWN);
+                    pos += dest  + (float)FORMATION_WIDTH*(orient*WorldEntity::DOWN);
                     i = 1;
-                    dest += FORMATION_LENGTH*(orient*WorldEntity::BACK);
+                    dest += (float)FORMATION_LENGTH*(orient*WorldEntity::BACK);
                     (*it)->setTargetPosition(pos);
                     continue;
Index: code/trunk/src/orxonox/graphics/MeshLodInformation.cc
===================================================================
--- code/trunk/src/orxonox/graphics/MeshLodInformation.cc	(revision 7182)
+++ code/trunk/src/orxonox/graphics/MeshLodInformation.cc	(revision 7183)
@@ -41,5 +41,5 @@
 
     MeshLodInformation::MeshLodInformation(BaseObject* creator)
-    : BaseObject(creator), lodLevel_(5), bEnabled_(true), numLevels_(10), reductionRate_(0.15)
+    : BaseObject(creator), lodLevel_(5), bEnabled_(true), numLevels_(10), reductionRate_(0.15f)
     {
         RegisterObject(MeshLodInformation);
Index: code/trunk/src/orxonox/graphics/Model.cc
===================================================================
--- code/trunk/src/orxonox/graphics/Model.cc	(revision 7182)
+++ code/trunk/src/orxonox/graphics/Model.cc	(revision 7183)
@@ -44,5 +44,5 @@
 
     Model::Model(BaseObject* creator) :
-        StaticEntity(creator), bCastShadows_(true), lodLevel_(5), bLodEnabled_(true), numLodLevels_(10), lodReductionRate_(.15)
+        StaticEntity(creator), bCastShadows_(true), lodLevel_(5), bLodEnabled_(true), numLodLevels_(10), lodReductionRate_(.15f)
     {
         RegisterObject(Model);
Index: code/trunk/src/orxonox/weaponsystem/WeaponSystem.cc
===================================================================
--- code/trunk/src/orxonox/weaponsystem/WeaponSystem.cc	(revision 7182)
+++ code/trunk/src/orxonox/weaponsystem/WeaponSystem.cc	(revision 7183)
@@ -222,7 +222,7 @@
 
         // Remove the WeaponPack from the WeaponSystem
-        std::vector<WeaponPack*>::iterator it = std::find(this->weaponPacks_.begin(),this->weaponPacks_.end(), wPack);
-        assert(it !=this->weaponPacks_.end());
-        this->weaponPacks_.erase(it);
+        std::vector<WeaponPack*>::iterator it2 = std::find(this->weaponPacks_.begin(),this->weaponPacks_.end(), wPack);
+        assert(it2 !=this->weaponPacks_.end());
+        this->weaponPacks_.erase(it2);
     }
 
Index: code/trunk/src/orxonox/worldentities/pawns/FpsPlayer.cc
===================================================================
--- code/trunk/src/orxonox/worldentities/pawns/FpsPlayer.cc	(revision 7182)
+++ code/trunk/src/orxonox/worldentities/pawns/FpsPlayer.cc	(revision 7183)
@@ -171,21 +171,21 @@
 
                 Radian pitch = this->cameraPositionRootNode_->getOrientation().getPitch();
-                if (pitch < Radian(1.5707) && pitch > Radian(-1.5707))
+                if (pitch < Radian(1.5707f) && pitch > Radian(-1.5707f))
                 {
                     this->cameraPositionRootNode_->pitch(Radian(this->pitch_ * this->getMouseLookSpeed()));
                 }
-                else if (pitch < Radian(-1.5707))
+                else if (pitch < Radian(-1.5707f))
                 {
-                    if (this->pitch_ > 0.0)
+                    if (this->pitch_ > 0.0f)
                         this->cameraPositionRootNode_->pitch(Radian(this->pitch_ * this->getMouseLookSpeed()));
-                    else if (pitch < Radian(-1.571))
-                        this->cameraPositionRootNode_->pitch(-pitch + Radian(-1.570796));
+                    else if (pitch < Radian(-1.571f))
+                        this->cameraPositionRootNode_->pitch(-pitch + Radian(-1.570796f));
                 }
-                else if (pitch > Radian(1.5707))
+                else if (pitch > Radian(1.5707f))
                 {
-                    if (this->pitch_ < 0.0)
+                    if (this->pitch_ < 0.0f)
                         this->cameraPositionRootNode_->pitch(Radian(this->pitch_ * this->getMouseLookSpeed()));
-                    else if (pitch > Radian(1.571))
-                        this->cameraPositionRootNode_->pitch(-pitch + Radian(1.570796));
+                    else if (pitch > Radian(1.571f))
+                        this->cameraPositionRootNode_->pitch(-pitch + Radian(1.570796f));
                 }
                 this->weaponNode_->setOrientation(this->cameraPositionRootNode_->getOrientation());